#include <cstdio>

int dx[]= {0,0, 1, -1};
int dy[]={1,-1,0,0};

int N, M;
char c[102][102];

bool ins(int a,int b) {
	return a>=0 && a < N && b >=0 && b < M;
}

char d[102][102];

bool check(int a, int b) {
	d[a][b] = 'X';
	
	for(int i=0; i<4; i++) {
		int x = a + dx[i];
		int y = b + dy[i];
		if (ins(x, y) && d[x][y] == '.' && !check(x, y)) {
			d[a][b] = '.';
			return true;
		}
	}
	
	d[a][b] = '.';
	return false;
}

int main() {
	while(true) {
		scanf("%d %d",&N, &M);
		if (N == 0 ) return 0;
		for(int i=0; i<N; i++) {
			scanf("%s", c[i]);
			for(int j=0; j<M; j++) {
				d[i][j] = c[i][j];
			}
		}
		
		for(int i=0; i<N; i++) {
			for(int j=0; j<M; j++) {
				if (c[i][j] == 'X') putchar('X');
				else if (check(i, j)) {
					putchar('A');	
				} else {
					putchar('B');
				}
			}
			puts("");
		}
		puts("");
	}
	
	return 0;
}
